//Train Track Include File 1.0

//Textures
#declare Wood =
texture{
 pigment{
  wood
   color_map{
    [0.00 rgb <0.45, 0.10, 0.05> ]
    [0.65 rgb <0.65, 0.25, 0.15> ]
   }
  rotate<2, 90, 0>
  scale 0.10
 }
}

#declare Silver =
texture{
 pigment{
  color rgb 0.75
 }
 finish{
  metallic
 }
}

//SubItems
#declare RailWidth = 0.0625;
#declare RailHeight = 0.125;
#declare Width = 0.75;
#declare Radius = 18.5;
#declare RungSpace = 0.295;

#declare Rung =
box{
 <-0.5625, 0, -0.0625>
 <0.5625, 0.0625, 0.0625>
 texture{ Wood }
}

#declare StraightTrack =
union{
//Rails
 union{
  box{
   <-(RailWidth/2), 0, -4.5>
   <(RailWidth/2), RailHeight, 4.5>
   translate<-(Width/2), 0, 0>
  }
  box{
   <-(RailWidth/2), 0, -4.5>
   <(RailWidth/2), RailHeight, 4.5>
   translate<(Width/2), 0, 0>
  }
  texture{ Silver }
 }
 #declare Counter = 0;
 #while( Counter < 31 )
  object{ Rung
   translate<0, 0, -4.4375+(Counter*RungSpace)>
  }
  #declare Counter = Counter + 1;
 #end
}

#declare CurveTrack =
union{
 difference{
  union{
//Top Rail
   difference{
    cylinder{
     <0, 0, 0>
     <0, RailHeight, 0>
     Radius
    }
    cylinder{
     <0, -1, 0>
     <0, RailHeight+1, 0>
     Radius-(RailWidth)
    }
   }
//Bottom Rail
   difference{
    cylinder{
     <0, 0, 0>
     <0, RailHeight, 0>
     Radius-(Width)
    }
    cylinder{
     <0, -1, 0>
     <0, RailHeight+1, 0>
     (Radius-(RailWidth))-(Width)
    }
   }
  }
  box{
   <-4.00, -1.00, -2.00>
   <4.00, 1.00, 2.00>
   rotate<0, 19, 0>
   translate<-18.75, 0, 7.25>
  }
  box{
   <-4.00, -1.00, -2.00>
   <4.00, 1.00, 2.00>
   rotate<0, -19, 0>
   translate<-18.75, 0, -7.25>
  }
  box{
   <-20.00, -1.00, 7.25>
   <20.00, 1.00, 20.00>
  }
  box{
   <-20.00, -1.00, -7.25>
   <20.00, 1.00, -20.00>
  }
  box{
   <0.00, -1.00, -20>
   <20.00, 1.00, 20>
  }
  texture{ Silver }
 }
//Rungs
 #declare Counter = 0;
 #while (Counter < 17)
   object{ Rung translate<-18.075, 0, 0> rotate<0, (Counter*0.885), 0> }
  #declare Counter = Counter + 1;
 #end
 #declare Counter = 0;
 #while (Counter < 16)
   object{ Rung translate<-18.075, 0, 0> rotate<0, -0.885+-(Counter*0.885), 0> }
  #declare Counter = Counter + 1;
 #end
//Translate and Rotate so it is easier to put track together
 rotate<0, 16.80, 0>
 translate<18.075, 0, -5.10>
}
